;; set all entity properties in a block to ByBlock / Layer 0

(defun C:AllToByBlock ( / selset n m blkst insnme entdat entity)
 (if (not (setq selset (ssget "I" '((0 . "INSERT")))))
  (progn
   (princ "\nSelect block-instance(s): ")
   (setq selset (ssget '((0 . "INSERT"))))
  )
 )
 (if selset
  (progn
   (setq n 0 m 0 blklst '())
   (repeat (sslength selset)
    (if
     (or
      (eq 4 (logand 4 (cdr (assoc 70 (setq entdat (tblsearch "BLOCK" (setq insnme (cdr (assoc 2 (entget (ssname selset n)))))))))))
      (member insnme blklst)
     )
     (setq n (+ 1 n))
     (progn
      (setq blklst (cons insnme blklst))
      (setq entity (cdr (assoc -2 entdat)))
      (while entity
       (setq entdat (vl-remove-if '(lambda (x) (member (car x) '(6 8 62 370 440))) (entget entity)))
       (setq entdat (append entdat '((6 . "ByBlock") (8 . "0") (62 . 0) (370 . -2) (440 . 16777216))))
       (entmod entdat)
       (setq entity (entnext entity))
      )
      (setq n (+ 1 n) m (+ 1 m))
     )
    )
   )
   (princ (strcat "\nConverted entity properties in " (itoa m) " block definition(s)."))
  )
  (princ "\nNo block insertions found.")
 )
 (princ)
)
